#require 'win32/dir'
module JF
	module FolderBrowser
	module_function
	def start
		@dlg = UI::WebDialog.new("Browse for Folder", true, "JF::FolderBrowser", 300,400, 50, 50)
		file = File.join(File.dirname(__FILE__), "folder_browser.html")
		@dlg.min_width = 300
		@dlg.set_file(file)
		@dlg.add_action_callback("jserr") { |d, a|
			p a
		}
		@dlg.add_action_callback("folder") do |d, a|
			puts "folder: #{a.inspect}"
			pwd = Dir.pwd
			puts "pwd:#{pwd.inspect}"
			Dir.chdir(a)
			new_d = File.join(Dir.pwd, "*")
			#puts "new_d:#{new_d.inspect}"
			d.execute_script('clear_list()')
			populate(Dir.pwd)
		end
		@dlg.add_action_callback('use_this') { |d, a|
			puts "Selected: #{a.inspect}"
			d.close
		}
		@dlg.show { populate }
	end
	def populate(dir = nil)
		list = []
		if dir.nil?
			#dir = Dir::PERSONAL
			dir = Dir.pwd
		end
		Dir.chdir(dir)
		pwd = Dir.pwd
		@dlg.execute_script('set_location("' + pwd + '");')
		Dir[pwd+"/*"].sort.each do |file|
			#next if file[0] == ?.
			next unless File.directory?(file)
			list.push(file)
		end
		scr = 'appendDiv("../");'
		@dlg.execute_script(scr)
		list.each do |name|
			name = File.basename(name)
			scr = 'appendDiv("' + name + '");'
			@dlg.execute_script(scr)
		end
	end
	end
end
unless file_loaded?(__FILE__)
	UI.menu.add_item("Folder Browser") { JF::FolderBrowser.start }
end
file_loaded(__FILE__)
